#include "run.hh"


MyRunAction::MyRunAction(){
    auto *man = G4AnalysisManager::Instance();
    man->CreateNtuple("Gammas","Gammas");
    man->CreateNtupleIColumn("fEvent");
    man->CreateNtupleDColumn("fX");
    man->CreateNtupleDColumn("fY");
    man->CreateNtupleDColumn("fZ");
    
    man->FinishNtuple(0);
    man->CreateNtuple("E","E");
    man->CreateNtupleDColumn("fEdep");
    man->FinishNtuple(1);
}
MyRunAction::~MyRunAction(){}

void MyRunAction::BeginOfRunAction(const G4Run* run){
    auto *man = G4AnalysisManager::Instance();

    G4int runNumber = run->GetRunID();
    std::stringstream strRunID;
    strRunID << runNumber;

    G4String fileName = "output"+strRunID.str()+".root";
    man->OpenFile(fileName);
}
void MyRunAction::EndOfRunAction(const G4Run*){
    G4AnalysisManager *man = G4AnalysisManager::Instance();
    man->Write();
    man->CloseFile();
}