#include "stepping.hh"

MySteppingAction::MySteppingAction(MyEventAction *eventAction){
    fEventAction = eventAction;
}

MySteppingAction::~MySteppingAction(){}

void MySteppingAction::UserSteppingAction(const G4Step *step){

    const MyDetectorConstruction* detectorConstruction = static_cast<const MyDetectorConstruction*>(G4RunManager::GetRunManager()->GetUserDetectorConstruction());
    
    G4LogicalVolume* logicTube = detectorConstruction->GetLogicTube();
    G4LogicalVolume* logicEndcap = detectorConstruction->GetLogicEndcap();
    G4LogicalVolume* logicBeCylinder = detectorConstruction->GetLogicBeCylinder();

    G4LogicalVolume* volume = step->GetPreStepPoint()->GetTouchableHandle()->GetVolume()->GetLogicalVolume();

    if (volume == logicTube || volume == logicEndcap) {
        step->GetTrack()->SetTrackStatus(fStopAndKill);
    }

    G4LogicalVolume *fScoringVolume = detectorConstruction->GetScoringVolume();

    if(volume != fScoringVolume)
        return;

    G4double edep = step->GetTotalEnergyDeposit();
    fEventAction->AddEdep(edep);
}